## haskell-tamarin-prover-accountability-1.10.0-140.src.tar.gz

=== examples/sapic/Makefile ===
include Makefile.include

BENCHMARKFILES = GJM-contract/contract.spthy.benchmark MoedersheimWebService/set-abstr-lookup.spthy.benchmark NSL/nsl-no_as-untagged.spthy.benchmark StatVerifLeftRight/stateverif_left_right.spthy.benchmark EncWrapDecUnwrap/encwrapdecunwrap.spthy.benchmark
# EncWrapDecUnwrap
BENCHMARKFILESNOH = $(subst benchmark,benchmark-noh,$(BENCHMARKFILES))
DATETIME = $(shell date "+%Y-%m-%d-%H:%M:%S")

TESTFILES = $(subst sapic,spthy,$(wildcard fairexchange-mini/*.sapic))

.PHONY: all benchmark-compute benchmark-verify benchmark-show

all: $(FILES).check

benchmark-compute: $(BENCHMARKFILES)
benchmark-show: $(BENCHMARKFILES)
	@for file in $(BENCHMARKFILES); do echo "$$file: "; tail -n 3 $$file | grep real; done
benchmark-verify: $(BENCHMARKFILES)
	@for file in $(BENCHMARKFILES); do echo "$$file: "; tail -n 20 "$$file-cert" | grep steps ; done

benchmark-noh-compute: $(BENCHMARKFILESNOH)
benchmark-noh-show: $(BENCHMARKFILESNOH)
	@for file in $(BENCHMARKFILESNOH); do echo "$$file: "; tail -n 3 $$file | grep real; done
benchmark-noh-verify: $(BENCHMARKFILESNOH)
	@for file in $(BENCHMARKFILESNOH); do echo "$$file: "; tail -n 20 "$$file-cert" | grep steps ; done


test: $(TESTFILES)
	    $(PROVER) $(FLAGS) --prove $(TESTFILES) | grep --color -E 'falsified|$$'

%.spthy: %.sapic
	$(SAPIC) $< > $@

%.trans: %.sapic
	$(SAPIC) $< 

%.check: %
	$(PROVER) $(FLAGS) $<

%.proof: %
	$(PROVER) $(FLAGS) --prove$(PROOFFLAGS) $<

%.altproof: %
	$(ALTPROVER) $(FLAGS) --prove$(PROOFFLAGS) $<

%.interactive: %
	$(PROVER) interactive $(INTERACTIVEFLAGS) $< 2> /dev/null & 
	sleep 1
	open http://localhost:3001
	
# Example make HOST=colossus11 testfile.spthy.remote-interactive
%.remote-interactive: %
	scp $< $(HOST):spthy/
	ssh -t -L $($(HOST)LOCALPORT):localhost:$($(HOST)REMOTEPORT) \
	$(HOST) 'cd spthy; $($(HOST)ULIMITS); $($(HOST)PROVER) interactive --port=$($(HOST)REMOTEPORT) $($(HOST)INTERACTIVEFLAGS) $(notdir $<)'
	sleep 1
	open http://localhost:$($(HOST)LOCALPORT)

%.remote-proof: %
	scp $< $(HOST):spthy/
	ssh -t $(HOST) 'cd spthy; $($(HOST)ULIMITS); $($(HOST)PROVER) --prove$(PROOFFLAGS) $($(HOST)FLAGS) $(notdir $<)'

%.remote-check: %
	scp $< $(HOST):spthy/
	ssh -t $(HOST) 'cd spthy; $($(HOST)ULIMITS); $($(HOST)PROVER) $($(HOST)FLAGS) $(notdir $<)'

%.remote-quietproof: %
	scp $< $(HOST):spthy/
	ssh $(HOST) "tmux new-window 'cd spthy; $($(HOST)ULIMITS);LC_ALL=en_US.utf8 /usr/bin/time $($(HOST)PROVER) --prove$(PROOFFLAGS) $($(HOST)FLAGS) $(notdir $<) 2>$(notdir $<)-$(HOST)-$(DATETIME).errorlog | tee $(notdir $<)-$(HOST)-$(DATETIME).log '"

%.remote-quietinteractive: %
	scp $< $(HOST):spthy/
	ssh $(HOST) "tmux new-window 'cd spthy; $($(HOST)ULIMITS); $($(HOST)PROVER) interactive --port=$($(HOST)REMOTEPORT) $($(HOST)INTERACTIVEFLAGS) $(notdir $<) 2>$(notdir $<)-$(HOST)-$(DATETIME).errorlog | tee $(notdir $<)-$(HOST)-$(DATETIME).log'"
	sleep 1
	ssh -f -N -t -L $($(HOST)LOCALPORT):localhost:$($(HOST)REMOTEPORT) $(HOST) 
	open http://localhost:$($(HOST)LOCALPORT)

%.benchmark-rechen: %
	scp $< rechen:spthy/
	ssh rechen 'cd spthy; killall tamarin-prover; $(ULIMITSRECHEN); $(REMOTEPROVER) --prove$(PROOFFLAGS) $(REMOTEFLAGS) $<'

%.benchmark: %
	scp $< $(BENCHMARKMACHINE):spthy/
	ssh $(BENCHMARKMACHINE) 'cd spthy; killall tamarin-prover; $(BENCHMARKULIMITS); time $(BENCHMARKPROVER) --prove$(PROOFFLAGS) $(BENCHMARKFLAGS) $(notdir $<)' > $@-cert 2> $@

%.benchmark-noh: %
	scp $< $(BENCHMARKMACHINE):spthy/
	ssh $(BENCHMARKMACHINE) 'cd spthy; killall tamarin-prover; $(BENCHMARKULIMITS); time $(BENCHMARKPROVER) --prove$(PROOFFLAGS) $(BENCHMARKFLAGSNOH) $(notdir $<)' > $@-cert 2> $@

=== examples/sapic/deprecated/accountability-old/Makefile ===
include Makefile.include

BENCHMARKFILES =  whodunit_signatures.spthy.benchmark
BENCHMARKFILESNOH = $(subst benchmark,benchmark-noh,$(BENCHMARKFILES))
DATETIME = $(shell date "+%Y-%m-%d-%H:%M:%S")

TESTFILES = $(subst sapic,spthy,$(wildcard fairexchange-mini/*.sapic))

.PHONY: all benchmark-compute benchmark-verify benchmark-show

all: $(FILES).check

benchmark-compute: $(BENCHMARKFILES)
benchmark-show: $(BENCHMARKFILES)
	@for file in $(BENCHMARKFILES); do echo "$$file: "; tail -n 3 $$file | grep real; done
benchmark-verify: $(BENCHMARKFILES)
	@for file in $(BENCHMARKFILES); do echo "$$file: "; tail -n 20 "$$file-cert" | grep steps | grep --color -E 'falsified|$$'; done

test: $(TESTFILES)
	    $(PROVER) $(FLAGS) --prove $(TESTFILES) | grep --color -E 'falsified|$$'

%.spthy: %.sapic
	$(SAPIC) $< > $@

%.trans: %.sapic
	$(SAPIC) $< 

%.check: %
	$(PROVER) $(FLAGS) $<

%.proof: %
	$(PROVER) $(FLAGS) --prove$(PROOFFLAGS) $<

%.altproof: %
	$(ALTPROVER) $(FLAGS) --prove$(PROOFFLAGS) $<

%.interactive: %
	$(PROVER) interactive $(INTERACTIVEFLAGS) $< 2> /dev/null & 
	sleep 1
	open http://localhost:3001
	
# Example make HOST=colossus11 testfile.spthy.remote-interactive
%.remote-interactive: %
	scp $< $(HOST):spthy/
	ssh -t -L $($(HOST)LOCALPORT):localhost:$($(HOST)REMOTEPORT) \
	$(HOST) 'cd spthy; $($(HOST)ULIMITS); $($(HOST)PROVER) interactive --port=$($(HOST)REMOTEPORT) $($(HOST)INTERACTIVEFLAGS) $(notdir $<)'
	sleep 1
	open http://localhost:$($(HOST)LOCALPORT)

%.remote-proof: %
	scp $< $(HOST):spthy/
	ssh -t $(HOST) 'cd spthy; $($(HOST)ULIMITS); $($(HOST)PROVER) --prove$(PROOFFLAGS) $($(HOST)FLAGS) $(notdir $<)'

%.remote-check: %
	scp $< $(HOST):spthy/
	ssh -t $(HOST) 'cd spthy; $($(HOST)ULIMITS); $($(HOST)PROVER) $($(HOST)FLAGS) $(notdir $<)'

%.remote-quietproof: %
	scp $< $(HOST):spthy/
	ssh $(HOST) "tmux new-window 'cd spthy; $($(HOST)ULIMITS);LC_ALL=en_US.utf8 /usr/bin/time $($(HOST)PROVER) --prove$(PROOFFLAGS) $($(HOST)FLAGS) $(notdir $<) 2>$(notdir $<)-$(HOST)-$(DATETIME).errorlog | tee $(notdir $<)-$(HOST)-$(DATETIME).log '"

%.remote-quietinteractive: %
	scp $< $(HOST):spthy/
	ssh $(HOST) "tmux new-window 'cd spthy; $($(HOST)ULIMITS); $($(HOST)PROVER) interactive --port=$($(HOST)REMOTEPORT) $($(HOST)INTERACTIVEFLAGS) $(notdir $<) 2>$(notdir $<)-$(HOST)-$(DATETIME).errorlog | tee $(notdir $<)-$(HOST)-$(DATETIME).log'"
	sleep 1
	ssh -f -N -t -L $($(HOST)LOCALPORT):localhost:$($(HOST)REMOTEPORT) $(HOST) 
	open http://localhost:$($(HOST)LOCALPORT)

%.benchmark: %
	/usr/bin/time $(PROVER) $(FLAGS) --prove$(PROOFFLAGS) $<  > $@-cert 2> $@

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>
# Contributor: Arch Haskell Team <arch-haskell@haskell.org>

_hkgname=tamarin-prover-accountability
pkgname=haskell-tamarin-prover-accountability
pkgver=1.10.0
pkgrel=140
pkgdesc="Library for accountability for the tamarin prover"
url="http://www.infsec.ethz.ch/research/software/tamarin"
license=("GPL")
arch=('x86_64')
depends=('ghc-libs' 'haskell-aeson' 'haskell-aeson-pretty' 'haskell-dlist' 'haskell-fclabels'
         'haskell-parallel' 'haskell-safe' 'haskell-uniplate' 'haskell-raw-strings-qq'
         'haskell-tamarin-prover-utils' 'haskell-tamarin-prover-term'
         'haskell-tamarin-prover-theory')
makedepends=('ghc' 'uusi')
source=("tamarin-prover-$pkgver.tar.gz::https://github.com/tamarin-prover/tamarin-prover/archive/$pkgver.tar.gz")
sha512sums=('52ea3e77051208ab2f2b9425988640a2a699adfaaac90d5946d3ce43663ad535f5efb1bf845e0d540eb719e0f26c4d8beec4e231f54f0f393f42c2a392cfd486')

prepare() {
    cd "tamarin-prover-${pkgver}/lib/accountability"
    gen-setup
}

build() {
    cd "${srcdir}/tamarin-prover-${pkgver}/lib/accountability"
    
    runhaskell Setup configure -O --enable-shared --enable-debug-info --enable-executable-dynamic --disable-library-vanilla \
        --prefix=/usr --docdir=/usr/share/doc/$pkgname --datasubdir=$pkgname --enable-tests \
        --dynlibdir=/usr/lib --libsubdir=\$compiler/site-local/\$pkgid
    runhaskell Setup build $MAKEFLAGS
    runhaskell Setup register --gen-script
    runhaskell Setup unregister --gen-script
    sed -i -r -e "s|ghc-pkg.*update[^ ]* |&'--force' |" register.sh
    sed -i -r -e "s|ghc-pkg.*unregister[^ ]* |&'--force' |" unregister.sh
}

check() {
    cd "${srcdir}/tamarin-prover-${pkgver}/lib/accountability"
    runhaskell Setup test --show-details=direct
}

package() {
    cd "${srcdir}/tamarin-prover-${pkgver}/lib/accountability"
    
    install -D -m744 register.sh "$pkgdir"/usr/share/haskell/register/$pkgname.sh
    install -D -m744 unregister.sh "$pkgdir"/usr/share/haskell/unregister/$pkgname.sh
    runhaskell Setup copy --destdir="$pkgdir"
    rm -f "$pkgdir"/usr/share/doc/$pkgname/LICENSE
}
